const { arch, platform } = require('process')

const getBinaryPath = () => {
  const hostPackage = `@netlify/local-functions-proxy-${platform}-${arch}`

  try {
    // eslint-disable-next-line node/global-require
    const { optionalDependencies } = require('./package.json')

    if (optionalDependencies[hostPackage] === undefined) {
      return null
    }

    // eslint-disable-next-line import/no-dynamic-require, node/global-require
    const { binaryPath } = require(hostPackage)

    return binaryPath
  } catch (error) {
    console.error(`Could not load ${hostPackage}:`, error.message)

    return null
  }
}

module.exports = {
  getBinaryPath,
}
